﻿Imports System.Collections.Generic
Imports System.IO
Imports System.Net

Module Module1
    Dim calculateRouteUrl As String = "http://trackservice.trackroad.com/rest/route"
    Dim trackServiceKey As String = "your_trackservice_key"

    Sub Main()
        'Make a request.
        CalculateRoute(trackServiceKey)
    End Sub


    Sub CalculateRoute(key As String)
        'A data to send.
        Dim postData As String = "{""Locations"":[{""MatchCode"":0,""Name"":""Loc_1"",""Delivery"":null,""Vehicle"":null,""Description"":null,""Phone"":null,""LatLong"":{""Latitude"":38.931594,""Longitude"":-77.27602},""Address"":null,""Priority"":0,""Wait"":0,""Volume"":0,""Weight"":0,""Skids"":0,""TimeConstraintArrival"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture"":""0001-01-01T00:00:00Z"",""TimeConstraintArrival2"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture2"":""0001-01-01T00:00:00Z"",""LocationType"":0,""CanArriveEarly"":true,""Distance"":0,""Time"":0},{""MatchCode"":0,""Name"":""Loc_2"",""Delivery"":null,""Vehicle"":null,""Description"":null,""Phone"":null,""LatLong"":{""Latitude"":38.938467,""Longitude"":-77.164874},""Address"":null,""Priority"":0,""Wait"":0,""Volume"":0,""Weight"":0,""Skids"":0,""TimeConstraintArrival"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture"":""0001-01-01T00:00:00Z"",""TimeConstraintArrival2"":""0001-01-01T00:00:00Z"",""TimeConstraintDeparture2"":""0001-01-01T00:00:00Z"",""LocationType"":0,""CanArriveEarly"":true,""Distance"":0,""Time"":0}],""RouteOptions"":{""DistanceUnit"":0,""RouteOptimize"":0,""Culture"":""en-US"",""MapSize"":null,""RouteColor"":null}}"
        Dim response As String = Nothing

        Try
            'Make a request.
            response = CallService(Convert.ToString(calculateRouteUrl & Convert.ToString("/")) & key, postData)
        Catch ex As Exception
            'Show exception.
            Console.WriteLine(ex.ToString())
            Return
        End Try
        Console.WriteLine("CalculateRoute:")
        Console.WriteLine(response)
        Console.WriteLine("Press any key to continue...")
        Console.ReadKey()
    End Sub

    ''' <summary>
    ''' Sends data to specified URL as POST request and returns response.
    ''' </summary>
    ''' <param name="url">Request Url</param>
    ''' <param name="postData">A data to send.</param>
    ''' <returns>Returns a response as a System.String.</returns>
    Function CallService(url As String, postData As String) As String
        Dim httpWReq As HttpWebRequest = DirectCast(WebRequest.Create(url), HttpWebRequest)

        Dim data As Byte() = System.Text.Encoding.UTF8.GetBytes(postData)

        httpWReq.Method = "POST"
        httpWReq.ContentType = "text/json; charset=utf-8"
        httpWReq.ContentLength = data.Length

        Using stream As Stream = httpWReq.GetRequestStream()
            stream.Write(data, 0, data.Length)
        End Using

        Dim response As HttpWebResponse = DirectCast(httpWReq.GetResponse(), HttpWebResponse)

        Dim responseString As String = New StreamReader(response.GetResponseStream()).ReadToEnd()

        Return responseString
    End Function

End Module